#ifndef T1M_GAME_AI_ABORTION_H
#define T1M_GAME_AI_ABORTION_H

#include "global/types.h"

#include <stdint.h>

#define ABORTION_DIE_ANIM 13
#define ABORTION_PART_DAMAGE 250
#define ABORTION_ATTACK_DAMAGE 500
#define ABORTION_TOUCH_DAMAGE 5
#define ABORTION_NEED_TURN (PHD_DEGREE * 45) // = 8190
#define ABORTION_TURN (PHD_DEGREE * 3) // = 546
#define ABORTION_ATTACK_RANGE SQUARE(2600) // = 6760000
#define ABORTION_CLOSE_RANGE SQUARE(2250) // = 5062500
#define ABORTION_TLEFT 0x7FF0
#define ABORTION_TRIGHT 0x3FF8000
#define ABORTION_TOUCH (ABORTION_TLEFT | ABORTION_TRIGHT)
#define ABORTION_HITPOINTS 500
#define ABORTION_RADIUS (WALL_L / 3) // = 341
#define ABORTION_SMARTNESS 0x7FFF

typedef enum {
    ABORTION_EMPTY = 0,
    ABORTION_STOP = 1,
    ABORTION_TURN_L = 2,
    ABORTION_TURN_R = 3,
    ABORTION_ATTACK1 = 4,
    ABORTION_ATTACK2 = 5,
    ABORTION_ATTACK3 = 6,
    ABORTION_FORWARD = 7,
    ABORTION_SET = 8,
    ABORTION_FALL = 9,
    ABORTION_DEATH = 10,
    ABORTION_KILL = 11,
} ABORTION_ANIM;

void SetupAbortion(OBJECT_INFO *obj);
void AbortionControl(int16_t item_num);

#endif
